proto_bin Module
     __________________________________________________________

   Table of Contents

   1. Admin Guide

        1.1. Overview
        1.2. Dependencies

              1.2.1. OpenSIPS Modules
              1.2.2. External Libraries or Applications

        1.3. Exported Parameters

              1.3.1. bin_port (integer)
              1.3.2. bin_send_timeout (integer)
              1.3.3. bin_max_msg_chunks (integer)
              1.3.4. bin_async (integer)
              1.3.5. bin_async_max_postponed_chunks (integer)
              1.3.6. bin_async_local_connect_timeout (integer)
              1.3.7. bin_async_local_write_timeout (integer)

   2. Contributors

        2.1. By Commit Statistics
        2.2. By Commit Activity

   3. Documentation

        3.1. Contributors

   List of Tables

   2.1. Top contributors by DevScore^(1), authored commits^(2) and
          lines added/removed^(3)

   2.2. Most recently active contributors^(1) to this module

   List of Examples

   1.1. Set bin_port parameter
   1.2. Set bin_send_timeout parameter
   1.3. Set bin_max_msg_chunks parameter
   1.4. Set bin_async parameter
   1.5. Set bin_async_max_postponed_chunks parameter
   1.6. Set bin_async_local_connect_timeout parameter
   1.7. Set bin_async_local_write_timeout parameter

Chapter 1. Admin Guide

1.1. Overview

   The proto_bin module is a transport module which implements
   Binary Interface TCP-based communication. It does not handle
   TCP connections management, but only offers higher-level
   primitives to read and write BIN messages over TCP. It calls
   registered callback functions for every complete message
   received.

   Once loaded, you will be able to define BIN listeners in your
   configuration file by adding their IP and, optionally, a
   listening port, similar to this example:

...
socket= bin:127.0.0.1           # change the listening IP
socket= bin:127.0.0.1:5080      # change the listening IP and port
...

1.2. Dependencies

1.2.1. OpenSIPS Modules

   The following modules must be loaded before this module:
     * None.

1.2.2. External Libraries or Applications

   The following libraries or applications must be installed
   before running OpenSIPS with this module loaded:
     * None.

1.3. Exported Parameters

1.3.1. bin_port (integer)

   The default port to be used by all TCP listeners.

   Default value is 5555.

   Example 1.1. Set bin_port parameter
...
modparam("proto_bin", "bin_port", 6666)
...

1.3.2. bin_send_timeout (integer)

   Time in milliseconds after a TCP connection will be closed if
   it is not available for blocking writing in this interval (and
   OpenSIPS wants to send something on it).

   Default value is 100 ms.

   Example 1.2. Set bin_send_timeout parameter
...
modparam("proto_bin", "bin_send_timeout", 200)
...

1.3.3. bin_max_msg_chunks (integer)

   The maximum number of chunks in which a BIN message is expected
   to arrive via TCP. If a received packet is more fragmented than
   this, the connection is dropped (either the connection is very
   overloaded and this leads to high fragmentation - or we are the
   victim of an ongoing attack where the attacker is sending very
   fragmented traffic in order to decrease server performance).

   Default value is 32.

   Example 1.3. Set bin_max_msg_chunks parameter
...
modparam("proto_bin", "bin_max_msg_chunks", 8)
...

1.3.4. bin_async (integer)

   Specifies whether the TCP connect and write operations should
   be done in an asynchronous mode (non-blocking connect and
   write) or not. If disabled, OpenSIPS will block and wait for
   TCP operations like connect and write.

   Default value is 1 (enabled).

   Example 1.4. Set bin_async parameter
...
modparam("proto_bin", "bin_async", 0)
...

1.3.5. bin_async_max_postponed_chunks (integer)

   If bin_async is enabled, this specifies the maximum number of
   BIN messages that can be stashed for later/async writing. If
   the connection pending writes exceed this number, the
   connection will be marked as broken and dropped.

   Default value is 1024.

   Example 1.5. Set bin_async_max_postponed_chunks parameter
...
modparam("proto_bin", "bin_async_max_postponed_chunks", 1024)
...

1.3.6. bin_async_local_connect_timeout (integer)

   If bin_async is enabled, this specifies the number of
   milliseconds that a connect will be tried in blocking mode
   (optimization). If the connect operation lasts more than this,
   the connect will go to async mode and will be passed to TCP
   MAIN for polling.

   Default value is 100 ms.

   Example 1.6. Set bin_async_local_connect_timeout parameter
...
modparam("proto_bin", "bin_async_local_connect_timeout", 200)
...

1.3.7. bin_async_local_write_timeout (integer)

   If bin_async is enabled, this specifies the number of
   milliseconds that a write op will be tried in blocking mode
   (optimization). If the write operation lasts more than this,
   the write will go to async mode and will be passed to bin MAIN
   for polling.

   Default value is 10 ms.

   Example 1.7. Set bin_async_local_write_timeout parameter
...
modparam("proto_bin", "tcp_async_local_write_timeout", 100)
...

Chapter 2. Contributors

2.1. By Commit Statistics

   Table 2.1. Top contributors by DevScore^(1), authored
   commits^(2) and lines added/removed^(3)
     Name DevScore Commits Lines ++ Lines --
   1. Razvan Crainea (@razvancrainea) 28 19 60 467
   2. Vlad Patrascu (@rvlad-patrascu) 15 4 954 140
   3. Ionel Cerghit (@ionel-cerghit) 15 3 1196 38
   4. Liviu Chircu (@liviuchircu) 13 10 63 63
   5. Bogdan-Andrei Iancu (@bogdan-iancu) 9 7 29 9
   6. Maksym Sobolyev (@sobomax) 5 3 34 36
   7. Eseanu Marius Cristian (@eseanucristian) 4 2 1 5
   8. Nick Altmann (@nikbyte) 3 1 4 4
   9. Peter Lemenkov (@lemenkov) 3 1 1 1

   (1) DevScore = author_commits + author_lines_added /
   (project_lines_added / project_commits) + author_lines_deleted
   / (project_lines_deleted / project_commits)

   (2) including any documentation-related commits, excluding
   merge commits. Regarding imported patches/code, we do our best
   to count the work on behalf of the proper owner, as per the
   "fix_authors" and "mod_renames" arrays in
   opensips/doc/build-contrib.sh. If you identify any
   patches/commits which do not get properly attributed to you,
   please submit a pull request which extends "fix_authors" and/or
   "mod_renames".

   (3) ignoring whitespace edits, renamed files and auto-generated
   files

2.2. By Commit Activity

   Table 2.2. Most recently active contributors^(1) to this module
                        Name                     Commit Activity
   1. Liviu Chircu (@liviuchircu)              Mar 2016 - Dec 2024
   2. Maksym Sobolyev (@sobomax)               Feb 2023 - Nov 2023
   3. Razvan Crainea (@razvancrainea)          Aug 2015 - Jul 2023
   4. Vlad Patrascu (@rvlad-patrascu)          May 2017 - Oct 2021
   5. Nick Altmann (@nikbyte)                  May 2021 - May 2021
   6. Bogdan-Andrei Iancu (@bogdan-iancu)      Mar 2017 - Apr 2021
   7. Peter Lemenkov (@lemenkov)               Jun 2018 - Jun 2018
   8. Ionel Cerghit (@ionel-cerghit)           Jul 2015 - Dec 2016
   9. Eseanu Marius Cristian (@eseanucristian) Jul 2015 - Jul 2015

   (1) including any documentation-related commits, excluding
   merge commits

Chapter 3. Documentation

3.1. Contributors

   Last edited by: Liviu Chircu (@liviuchircu), Bogdan-Andrei
   Iancu (@bogdan-iancu), Peter Lemenkov (@lemenkov), Ionel
   Cerghit (@ionel-cerghit).

   Documentation Copyrights:

   Copyright © 2015 www.opensips-solutions.com
